Index: trunk/SophyaLib/BaseTools/stsrand.cc
===================================================================
--- trunk/SophyaLib/BaseTools/stsrand.cc	(revision 3599)
+++ trunk/SophyaLib/BaseTools/stsrand.cc	(revision 3612)
@@ -9,5 +9,5 @@
 
 /*!
-   \class RandomGenerator
+   \class STSRandGen
    \ingroup BaseTools
    \brief Random number generator
@@ -17,5 +17,5 @@
    random number generator used.
 
-   \sa SOPHYA::ObjFileIO<RandomGenerator>
+   \sa SOPHYA::ObjFileIO<STSRandGen>
 
    \sa frand01 drand01 frandpm1 drandpm1 
@@ -29,5 +29,5 @@
 static ThSafeOp* ths_rand = NULL;
 
-RandomGenerator::RandomGenerator(size_t n, bool tsafe) 
+STSRandGen::STSRandGen(size_t n, bool tsafe) 
 {
   if (ths_rand == NULL)  ths_rand = new ThSafeOp; 
@@ -44,5 +44,5 @@
 }
 
-RandomGenerator::RandomGenerator(RandomGenerator const & rg)
+STSRandGen::STSRandGen(STSRandGen const & rg)
 {
   if (ths_rand == NULL)  ths_rand = new ThSafeOp; 
@@ -59,10 +59,10 @@
 
 
-RandomGenerator::~RandomGenerator(void) 
+STSRandGen::~STSRandGen(void) 
 {
   // rien a faire 
 }
 
-void RandomGenerator::SetBuffSize(size_t n)
+void STSRandGen::SetBuffSize(size_t n)
 // redimensionnement du buffer
 {
@@ -73,5 +73,5 @@
 }
 
-void RandomGenerator::AutoInit(int lp)
+void STSRandGen::AutoInit(int lp)
 // Initialisation automatique (pseudo) aleatoire du generateur.
 // L'initialiseur est donne par un codage du nombre de millisecondes
@@ -133,5 +133,5 @@
     }
   }
-  if(lp>0) cout<<"RandomGenerator::AutoInit: "<<seed_16v[0]<<" "<<seed_16v[1]<<" "<<seed_16v[2]<<endl;
+  if(lp>0) cout<<"STSRandGen::AutoInit: "<<seed_16v[0]<<" "<<seed_16v[1]<<" "<<seed_16v[2]<<endl;
 
   // Initialise drand48()
@@ -139,8 +139,8 @@
 }
 
-void RandomGenerator::Init(long seed_val, int lp)
-{
-  if (ths_rand == NULL)  ths_rand = new ThSafeOp; 
-  if(lp) cout << "RandomGenerator::Init(long seed=" << seed_val << ")" << endl;
+void STSRandGen::Init(long seed_val, int lp)
+{
+  if (ths_rand == NULL)  ths_rand = new ThSafeOp; 
+  if(lp) cout << "STSRandGen::Init(long seed=" << seed_val << ")" << endl;
   ths_rand->lock();
   srand48(seed_val);
@@ -149,8 +149,8 @@
 }
 
-void RandomGenerator::Init(unsigned short seed_16v[3], int lp)
-{
-  if (ths_rand == NULL)  ths_rand = new ThSafeOp; 
-  if(lp) cout << "RandomGenerator::Init(u_short seed_16v[3]=" << seed_16v[0]
+void STSRandGen::Init(unsigned short seed_16v[3], int lp)
+{
+  if (ths_rand == NULL)  ths_rand = new ThSafeOp; 
+  if(lp) cout << "STSRandGen::Init(u_short seed_16v[3]=" << seed_16v[0]
 	      << "," << seed_16v[1] << "," << seed_16v[2] << ")" << endl;
   ths_rand->lock();
@@ -159,5 +159,5 @@
 }
 
-void RandomGenerator::GetSeed(unsigned short seed_16v[3], int lp)
+void STSRandGen::GetSeed(unsigned short seed_16v[3], int lp)
 {
   if (ths_rand == NULL)  ths_rand = new ThSafeOp; 
@@ -165,15 +165,15 @@
   GetSeed_P(seed_16v);
   ths_rand->unlock();
-  if(lp) cout << "RandomGenerator::GetSeed(u_short seed_16v[3]=" << seed_16v[0]
+  if(lp) cout << "STSRandGen::GetSeed(u_short seed_16v[3]=" << seed_16v[0]
 	      << "," << seed_16v[1] << "," << seed_16v[2] << ")" << endl;
   return;
 }
 
-void RandomGenerator::Init_P(unsigned short seed_16v[3])
+void STSRandGen::Init_P(unsigned short seed_16v[3])
 {
   seed48(seed_16v);
 }
 
-void RandomGenerator::GetSeed_P(unsigned short seed_16v[3])
+void STSRandGen::GetSeed_P(unsigned short seed_16v[3])
 {
   unsigned short seed[3] = {0,0,0};
@@ -186,5 +186,5 @@
 }
 
-r_8 RandomGenerator::Gaussian() 
+r_8 STSRandGen::Gaussian() 
 {
   r_8 A=Next(); 
@@ -194,5 +194,5 @@
 
 
-uint_8 RandomGenerator::Poisson(double mu,double mumax)
+uint_8 STSRandGen::Poisson(double mu,double mumax)
 {
   double pp,ppi,x;
@@ -218,5 +218,5 @@
 }
 
-void RandomGenerator::GenSeq(void)
+void STSRandGen::GenSeq(void)
 {
   ths_rand->lock();
@@ -228,13 +228,13 @@
 //----------------------------------------------------------
 // Classe pour la gestion de persistance
-// ObjFileIO<RandomGenerator>
+// ObjFileIO<STSRandGen>
 //----------------------------------------------------------
 
 /* --Methode-- */
 DECL_TEMP_SPEC  /* equivalent a template <> , pour SGI-CC en particulier */
-void        ObjFileIO<RandomGenerator>::WriteSelf(POutPersist& s) const
+void        ObjFileIO<STSRandGen>::WriteSelf(POutPersist& s) const
 {
   if (dobj == NULL)
-    throw NullPtrError("ObjFileIO<RandomGenerator>::WriteSelf() dobj=NULL");
+    throw NullPtrError("ObjFileIO<STSRandGen>::WriteSelf() dobj=NULL");
   ths_rand->lock();  // thread-safety
   uint_4 itab[6];
@@ -259,5 +259,5 @@
 /* --Methode-- */
 DECL_TEMP_SPEC  /* equivalent a template <> , pour SGI-CC en particulier */
-void        ObjFileIO<RandomGenerator>::ReadSelf(PInPersist& s)
+void        ObjFileIO<STSRandGen>::ReadSelf(PInPersist& s)
 {
   uint_4 itab[6];
@@ -268,5 +268,5 @@
   s.Get(ix);  // Taille du tableau intermediaire
 
-  if (dobj == NULL) dobj = new RandomGenerator(sz, (sz>0)?true:false);
+  if (dobj == NULL) dobj = new STSRandGen(sz, (sz>0)?true:false);
   dobj->idx_ = ix;
   if (sz > 0) { 
@@ -288,9 +288,9 @@
 // ---------------------------------------------------------
 #ifdef __CXX_PRAGMA_TEMPLATES__
-#pragma define_template ObjFileIO<RandomGenerator>
+#pragma define_template ObjFileIO<STSRandGen>
 #endif
 
 #if defined(ANSI_TEMPLATES) || defined(GNU_TEMPLATES)
-template class ObjFileIO<RandomGenerator>;
+template class ObjFileIO<STSRandGen>;
 #endif
 // ---------------------------------------------------------