Index: trunk/Cosmo/SimLSS/cmvchkwhu.cc
===================================================================
--- trunk/Cosmo/SimLSS/cmvchkwhu.cc	(revision 3618)
+++ trunk/Cosmo/SimLSS/cmvchkwhu.cc	(revision 3619)
@@ -21,4 +21,5 @@
  //double h100 = 0.71, Om0 = 0.2736, Ob0 = 0.0456, tcmb = T_CMB_Par; //WMAP5+BAO+SN
  //double h100 = 0.5, Om0 = 0.2, Ob0 = 0.1, tcmb = T_CMB_Par; //papier de Hu
+ //double h100 = 0.71, Om0 = 1.0, Ob0 = 0.0444356, tcmb = T_CMB_Par; // Om=1 Ob<<1
 
  cout<<"k1="<<k1<<"  k2="<<k2<<" npt="<<npt<<endl;
Index: trunk/Cosmo/SimLSS/genefluct3d.h
===================================================================
--- trunk/Cosmo/SimLSS/genefluct3d.h	(revision 3618)
+++ trunk/Cosmo/SimLSS/genefluct3d.h	(revision 3619)
@@ -14,4 +14,5 @@
 
 #include <vector>
+#include <algorithm>
 
 #include "cosmocalc.h"
Index: trunk/FrEROS/AnaLC/chkfsv.cc
===================================================================
--- trunk/FrEROS/AnaLC/chkfsv.cc	(revision 3618)
+++ trunk/FrEROS/AnaLC/chkfsv.cc	(revision 3619)
@@ -8,4 +8,5 @@
 #include <stdlib.h>
 #include <stdio.h>
+#include <string.h>
 #include <ctype.h>
 #include <math.h>
Index: trunk/SophyaExt/FitsIOServer/fitsfile.cc
===================================================================
--- trunk/SophyaExt/FitsIOServer/fitsfile.cc	(revision 3618)
+++ trunk/SophyaExt/FitsIOServer/fitsfile.cc	(revision 3619)
@@ -2,4 +2,5 @@
 #include "machdefs.h"
 #include <stdlib.h>
+#include <string.h>
 #include "fitsfile.h"
 #include "pexceptions.h"
Index: trunk/SophyaExt/FitsIOServer/fitsntuple.cc
===================================================================
--- trunk/SophyaExt/FitsIOServer/fitsntuple.cc	(revision 3618)
+++ trunk/SophyaExt/FitsIOServer/fitsntuple.cc	(revision 3619)
@@ -1,3 +1,4 @@
 #include "sopnamsp.h"
+#include <string.h>
 #include "pexceptions.h"
 #include "fitsntuple.h"
Index: trunk/SophyaExt/LinAlg/intflapack.cc
===================================================================
--- trunk/SophyaExt/LinAlg/intflapack.cc	(revision 3618)
+++ trunk/SophyaExt/LinAlg/intflapack.cc	(revision 3619)
@@ -1,3 +1,4 @@
 #include <iostream>
+#include <string.h>
 #include <math.h>
 #include "sopnamsp.h"
Index: trunk/SophyaLib/BaseTools/datatype.cc
===================================================================
--- trunk/SophyaLib/BaseTools/datatype.cc	(revision 3618)
+++ trunk/SophyaLib/BaseTools/datatype.cc	(revision 3619)
@@ -6,4 +6,5 @@
 #include "datatype.h"
 #include <typeinfo>
+#include <string.h>
 
 #include <complex>
Index: trunk/SophyaLib/BaseTools/dvlist.cc
===================================================================
--- trunk/SophyaLib/BaseTools/dvlist.cc	(revision 3618)
+++ trunk/SophyaLib/BaseTools/dvlist.cc	(revision 3619)
@@ -6,4 +6,5 @@
 #include <stdlib.h>
 #include <stdio.h>
+#include <string.h>
 
 #include "dvlist.h"
Index: trunk/SophyaLib/BaseTools/mutyv.cc
===================================================================
--- trunk/SophyaLib/BaseTools/mutyv.cc	(revision 3618)
+++ trunk/SophyaLib/BaseTools/mutyv.cc	(revision 3619)
@@ -7,4 +7,5 @@
 #include "mutyv.h"
 #include <stdio.h>
+#include <stdlib.h>
 
 #include <iostream>
Index: trunk/SophyaLib/BaseTools/ndatablock.cc
===================================================================
--- trunk/SophyaLib/BaseTools/ndatablock.cc	(revision 3618)
+++ trunk/SophyaLib/BaseTools/ndatablock.cc	(revision 3619)
@@ -7,4 +7,5 @@
 #include <stdlib.h>
 #include <iostream>
+#include <string.h>
 #include <complex>
 #include "pexceptions.h"
Index: trunk/SophyaLib/BaseTools/ppfbinstream.cc
===================================================================
--- trunk/SophyaLib/BaseTools/ppfbinstream.cc	(revision 3618)
+++ trunk/SophyaLib/BaseTools/ppfbinstream.cc	(revision 3619)
@@ -2,4 +2,6 @@
 #include "machdefs.h"
 #include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
 #include <sys/types.h>
 #include <time.h>
Index: trunk/SophyaLib/BaseTools/randr48.cc
===================================================================
--- trunk/SophyaLib/BaseTools/randr48.cc	(revision 3618)
+++ trunk/SophyaLib/BaseTools/randr48.cc	(revision 3619)
@@ -2,4 +2,5 @@
 #include <math.h> 
 #include <stdlib.h>
+#include <string.h>
 #include "thsafeop.h"
 #include "fiondblock.h"
Index: trunk/SophyaLib/BaseTools/stsrand.cc
===================================================================
--- trunk/SophyaLib/BaseTools/stsrand.cc	(revision 3618)
+++ trunk/SophyaLib/BaseTools/stsrand.cc	(revision 3619)
@@ -3,4 +3,5 @@
 //#include "srandgen.h"
 #include "fiondblock.h"
+#include <string.h>
 #include <math.h> 
 #include <sys/time.h>
Index: trunk/SophyaLib/HiStats/ntuple.cc
===================================================================
--- trunk/SophyaLib/HiStats/ntuple.cc	(revision 3618)
+++ trunk/SophyaLib/HiStats/ntuple.cc	(revision 3619)
@@ -1,3 +1,4 @@
 #include <stdio.h>
+#include <stdlib.h>
 #include <string.h>
 
Index: trunk/SophyaLib/NTools/datatypes.cc
===================================================================
--- trunk/SophyaLib/NTools/datatypes.cc	(revision 3618)
+++ trunk/SophyaLib/NTools/datatypes.cc	(revision 3619)
@@ -6,4 +6,5 @@
 
 #include "sopnamsp.h"
+#include <string.h>
 #include "datatypes.h"
 
Index: trunk/SophyaLib/SUtils/strutilxx.cc
===================================================================
--- trunk/SophyaLib/SUtils/strutilxx.cc	(revision 3618)
+++ trunk/SophyaLib/SUtils/strutilxx.cc	(revision 3619)
@@ -3,4 +3,5 @@
 #include <stdio.h>
 #include <stdlib.h>
+#include <string.h>
 #include <iostream>
 
Index: trunk/SophyaLib/Samba/datacirclefake.cc
===================================================================
--- trunk/SophyaLib/Samba/datacirclefake.cc	(revision 3618)
+++ trunk/SophyaLib/Samba/datacirclefake.cc	(revision 3619)
@@ -1,2 +1,3 @@
+#include <stdlib.h>
 #include <iostream>
 #include "sopnamsp.h"
Index: trunk/SophyaLib/Samba/scan.cc
===================================================================
--- trunk/SophyaLib/Samba/scan.cc	(revision 3618)
+++ trunk/SophyaLib/Samba/scan.cc	(revision 3619)
@@ -3,4 +3,5 @@
 #include <stdlib.h>
 #include <stdio.h>
+#include <string.h>
 #include <math.h>
 
Index: trunk/SophyaLib/SysTools/commander.cc
===================================================================
--- trunk/SophyaLib/SysTools/commander.cc	(revision 3618)
+++ trunk/SophyaLib/SysTools/commander.cc	(revision 3619)
@@ -3,4 +3,5 @@
 #include <stdio.h>
 #include <stdlib.h>
+#include <string.h>
 #include <unistd.h>
 #include <ctype.h>
Index: trunk/SophyaLib/SysTools/cxxcmplnk.cc
===================================================================
--- trunk/SophyaLib/SysTools/cxxcmplnk.cc	(revision 3618)
+++ trunk/SophyaLib/SysTools/cxxcmplnk.cc	(revision 3619)
@@ -5,4 +5,5 @@
 #include "cxxcmplnk.h"
 #include "sspvflags.h"
+#include <stdlib.h>
 #include <iostream>
 
Index: trunk/SophyaLib/SysTools/zthread.cc
===================================================================
--- trunk/SophyaLib/SysTools/zthread.cc	(revision 3618)
+++ trunk/SophyaLib/SysTools/zthread.cc	(revision 3619)
@@ -6,4 +6,5 @@
 #include <stdlib.h>
 #include <stdio.h>
+#include <string.h>
 #include <pthread.h>
 #include <signal.h>
Index: trunk/SophyaLib/TArray/tarray.cc
===================================================================
--- trunk/SophyaLib/TArray/tarray.cc	(revision 3618)
+++ trunk/SophyaLib/TArray/tarray.cc	(revision 3619)
@@ -5,4 +5,5 @@
 #include <stdio.h>
 #include <stdlib.h>
+#include <string.h>
 #include <math.h>
 #include <iomanip>
Index: trunk/SophyaLib/TArray/triangmtx.h
===================================================================
--- trunk/SophyaLib/TArray/triangmtx.h	(revision 3618)
+++ trunk/SophyaLib/TArray/triangmtx.h	(revision 3619)
@@ -4,4 +4,5 @@
 #define TRIANGMTX_H_SEEN
 
+#include <typeinfo>
 #include "ndatablock.h"
 #include "pexceptions.h"
Index: trunk/SophyaPI/PI/pipixutils.cc
===================================================================
--- trunk/SophyaPI/PI/pipixutils.cc	(revision 3618)
+++ trunk/SophyaPI/PI/pipixutils.cc	(revision 3619)
@@ -6,4 +6,5 @@
 #include <stdlib.h>
 #include <stdio.h>
+#include <string.h>
 #include <iostream>
 using namespace std;
Index: trunk/SophyaPI/PIext/pawexecut.cc
===================================================================
--- trunk/SophyaPI/PIext/pawexecut.cc	(revision 3618)
+++ trunk/SophyaPI/PIext/pawexecut.cc	(revision 3619)
@@ -4,4 +4,5 @@
 #include <iostream>
 #include <typeinfo>
+#include <algorithm>
 
 #include "sopnamsp.h"
Index: trunk/SophyaProg/PrgUtil/runcxx.cc
===================================================================
--- trunk/SophyaProg/PrgUtil/runcxx.cc	(revision 3618)
+++ trunk/SophyaProg/PrgUtil/runcxx.cc	(revision 3619)
@@ -3,4 +3,5 @@
 #include <stdio.h>
 #include <stdlib.h>
+#include <string.h>
 #include <math.h>
 #include <iostream>
Index: trunk/SophyaProg/PrgUtil/scanfits.cc
===================================================================
--- trunk/SophyaProg/PrgUtil/scanfits.cc	(revision 3618)
+++ trunk/SophyaProg/PrgUtil/scanfits.cc	(revision 3619)
@@ -1,4 +1,5 @@
 #include <stdio.h>
 #include <stdlib.h>
+#include <string.h>
 #include <math.h>
 #include <iostream>
Index: trunk/SophyaProg/PrgUtil/scanppf.cc
===================================================================
--- trunk/SophyaProg/PrgUtil/scanppf.cc	(revision 3618)
+++ trunk/SophyaProg/PrgUtil/scanppf.cc	(revision 3619)
@@ -1,4 +1,5 @@
 #include <stdio.h>
 #include <stdlib.h>
+#include <string.h>
 #include <typeinfo>
 #include <iostream>
Index: trunk/SophyaProg/Tests/tcmd.cc
===================================================================
--- trunk/SophyaProg/Tests/tcmd.cc	(revision 3618)
+++ trunk/SophyaProg/Tests/tcmd.cc	(revision 3619)
@@ -3,4 +3,5 @@
 #include <stdio.h>
 #include <stdlib.h>
+#include <string.h>
 #include <math.h>
 #include <iostream>
Index: trunk/SophyaProg/Tests/tnfits.cc
===================================================================
--- trunk/SophyaProg/Tests/tnfits.cc	(revision 3618)
+++ trunk/SophyaProg/Tests/tnfits.cc	(revision 3619)
@@ -3,4 +3,5 @@
 #include <stdio.h>
 #include <stdlib.h>
+#include <string.h>
 #include "math.h"
 #include <iostream>
Index: trunk/SophyaProg/Tests/tpipe.cc
===================================================================
--- trunk/SophyaProg/Tests/tpipe.cc	(revision 3618)
+++ trunk/SophyaProg/Tests/tpipe.cc	(revision 3619)
@@ -6,4 +6,5 @@
 #include <stdlib.h>
 #include <stdio.h>
+#include <string.h>
 #include <math.h>
 
Index: trunk/SophyaProg/Tests/tstppfwrapstl.cc
===================================================================
--- trunk/SophyaProg/Tests/tstppfwrapstl.cc	(revision 3618)
+++ trunk/SophyaProg/Tests/tstppfwrapstl.cc	(revision 3619)
@@ -3,4 +3,5 @@
 #include <stdio.h>
 #include <stdlib.h>
+#include <string.h>
 #include "math.h"
 #include <iostream>